\snow.xpl	26-Jun-2017
\Translation of Polaris's Snow.cpp program

\Data structures for snow flakes = very simple
def	Total_flakes=900;
def	Total_layers=3;
int	FlakesX(Total_flakes),
	FlakesY(Total_flakes),
	FlakesLayer(Total_flakes);


proc	Initialize_particle_flakes;	\Initialize the particle flakes
int	I;
[for I:= 0 to Total_flakes-1 do
	[FlakesX(I):= Ran(320);		\0-319 (x)
	 FlakesY(I):= Ran(200);		\0-199 (y)
	 FlakesLayer(I):= Ran(Total_layers); \(0-2) (layer)
	];
];


proc	Draw_particle_flakes;		\Draw all the particle flakes
int	I;
[for I:= 0 to Total_flakes-1 do
	[Point(FlakesX(I), FlakesY(I), FlakesLayer(I)*4+23);	\bright flakes
	\Note - we are drawing according to the default color palette
	];
];


proc	Update_particle_flakes;		\Update the particle flakes
int	I;
[for I:= 0 to Total_flakes-1 do
	[\Drop the particle down - depending on layer.
	 \Add one since layer zero would result in no motion
	FlakesY(I):= FlakesY(I) + FlakesLayer(I) + 1;

	\Check for wrap around
	if FlakesY(I) > 199 then
		[FlakesX(I):= Ran(320);
		 FlakesY(I):= 0;
		 FlakesLayer(I):= Ran(Total_layers);
		];

	\New X position
	FlakesX(I):= Rem((FlakesX(I)+2-Ran(5)) / 320);
	];
];


\	Main
[SetVid($13);			\set graphics display for 320x200x8-bit color
Initialize_particle_flakes;
while not KeyHit do
	[Update_particle_flakes;
	WaitForVSync;			\slow flakes
	WaitForVSync;
	WaitForVSync;
	WaitForVSync;
	Clear;
	Draw_particle_flakes;
	];
SetVid($03);			\restore normal text mode
]
