\circles.xpl
def	ScrW=1920, ScrH=1080;

proc	ShowFilledCircle(X0, Y0, R, C);	\Display a filled circle
int	X0, Y0,		\coordinates of center (pixels)
	R,		\radius (pixels)
	C;		\color
int	X, Y,		\working coordinates (pixels)
	R2, Y2;		\squared values
[R2:= R*R;
for Y:= -R to R do
	[Y2:= Y*Y;
	for X:= -R to R do
		if X*X + Y2 <= R2 then Point(X+X0, Y+Y0, C);
	];
];	\ShowFilledCircle

[SetFB(ScrW, ScrH, 32);
repeat	ShowFilledCircle(Ran(ScrW), Ran(ScrH), Ran(100), Ran($FF_FFFF) + Ran($100)<<24);
	DelayUS(55000);
until	KeyHit;
OpenI(0);
SetVid(3);
]
