\sieve.xpl
\Eratosthenes Sieve Prime Number Program

define	Size = 8190;
integer	Prime, Count, Iter, I, K;
char	Flags(Size+1);

[Text(0, "10000 iterations"); CrLf(0);
for Iter:= 1 to 10000 do			\do program 10000 times
	[Count:= 0;				\initialize prime counter
	for I:= 0 to Size do
		Flags(I):= true;		\set Flags all true
	for I:= 0 to Size do
	    if Flags(I) then			\found a prime
		[Prime:= I+I+3;			\twice the index + 3
		K:= I+Prime;			\first multiple to kill
		while K <= Size do
			[Flags(K):= false;	\zero a non-prime
			K:= K+Prime;		\next multiple of Prime
			];
		Count:= Count+1;		\primes found
		];
	];
IntOut(0, Count); Text(0, " primes
");						\primes found in 10000th pass
]
